close all;
%img = imread('courier.png');
img = imread('txt1.png');

%img = img(11:64,:,:);
%img = 255 - img;
%img(:,60:(60+size(img,2)-1),:) = img(:,:,:);


img_gray = 255 - mean(img,3);


imagesc(img_gray);
colormap(gray)
axis image;

thresh = 90;

over_darken = 1.2;

col_sums = sum(img_gray,1);

first_col = find(col_sums > thresh, 1);
last_col = find(col_sums > thresh, 1,'last');

split = (last_col - first_col) / 63;

first_col = first_col-round(split*1.2);
last_col = last_col + round(split/15);

split = (last_col - first_col) / 64;

%split = split * .9999;

bounds = first_col + round((0:64)*split);


height = size(img,1);
width = round(split*1.5);
char_img = zeros(height*4, width*16);
row = 1;
col = 1;
dark = zeros(1,63);
centroid = zeros(63,2);
dark_ch = cell(63,1);
for i=1:64
    matrix = img_gray(:,bounds(i):(bounds(i+1)-1));
    char_img(((row-1)*height+1):row*height,((col-1)*width+1):((col-1)*width+bounds(i+1)-bounds(i))) = matrix;
    dark(i) = sum(sum(img_gray(:,bounds(i):bounds(i+1))));
    dark_ch{i} = [i];
    matrix=matrix/sum(matrix(:));
    [m,n]=size(matrix);
    [m,n]=ndgrid(1:m,1:n);
    centroid(i,:) = [dot(m(:),matrix(:)),  dot(n(:),matrix(:))]; 
    col = col + 1;
    if col > 16;
        col = 1;
        row = row + 1;
    end;
end;
for i=1:16
    char_img(1:height*4,round((i-1)*width+split)) = 32;    
    char_img(1:height*4,i*width) = 32;
end;

imagesc(char_img);
    
[dark_sort, ix] = sort(dark);
dark_ch_sort = dark_ch(ix);
figure
plot(linspace(0,100,length(dark_sort)),dark_sort);

dark2 = zeros(floor(63*63/2),1);
ndx = 1;
ch = cell(64,1);
for ch1 = 1:64
   t = img_gray(:,bounds(ch1):(bounds(ch1+1)-1));
   t(1,ceil(split)) = 0;
   ch{ch1} = t;
end

dark2_ch = cell(64,1);
for ch1 = 1:64
    for ch2 = ch1:64
        over = ch{ch1} + ch{ch2};
        over = min(over, 255 * over_darken);
        dark2(ndx) = sum(sum(over));
        dark2_ch{ndx} = [ch1, ch2];
        ndx = ndx + 1;
    end
end;
hold all;
[dark2_sort, ix2] = sort(dark2);
dark2_ch_sort = dark2_ch(ix2);
plot(linspace(0,100,length(dark2_sort)),dark2_sort);

dark3 = zeros(43680,1);
ndx = 1;
dark3_ch = cell(64,1);
for ch1 = 1:64
    for ch2 = ch1:64
        for ch3 = ch2:64
            over = ch{ch1} + ch{ch2} + ch{ch3};
%            over = min(over, 255 * over_darken);
            over = min(over, 255 * over_darken * over_darken);            
            dark3(ndx) = sum(sum(over));
            dark3_ch{ndx} = [ch1, ch2, ch3];
            ndx = ndx + 1;
        end
    end
end;
hold all;
[dark3_sort, ix3] = sort(dark3);
dark3_ch_sort = dark3_ch(ix3);
plot(linspace(0,100,length(dark3_sort)),dark3_sort);
%plot(centroid(ix,:))
%char(32+dark_ndx_sort)

if 1
    dark_all = dark_sort;
    dark_all_ch = dark_ch_sort;
    dark_all = [dark_all, dark2_sort(dark2_sort > dark_sort(end))'];
    dark_all_ch = [dark_all_ch; dark2_ch_sort(dark2_sort > dark_sort(end))];
    dark_all = [dark_all, dark3_sort(dark3_sort > dark2_sort(end))'];
    dark_all_ch = [dark_all_ch; dark3_ch_sort(dark3_sort > dark2_sort(end))];
else
    dark_all = [dark_sort'; dark2_sort(1:end); dark3_sort(1:end)];
    dark_all_ch = [dark_ch_sort; dark2_ch_sort; dark3_ch_sort];
    [dark_all, ndx] = sort(dark_all);
    dark_all_ch = dark_all_ch(ndx);
end
figure
plot(dark_all);

levels = 16;

%dark_all = log(dark_all);
dark_all = dark_all .^ .5;


t = linspace(dark_all(2) - (dark_all(4) - dark_all(3)), dark_all(end), levels);
%t = dark_all(1), dark_all(end)
range = dark_all(end) - dark_all(1);


loc = zeros(levels,1);
chb = zeros(levels,3);
for i=1:levels
    [n, bin] = histc(t(i), dark_all);

%     if i > 1 & bin == bins(i-1)
%         bin = bin + 1;
%     end
    loc(i) = bin;        
    fprintf('Desired %.0f, got %.0f', t(i), dark_all(bin));
    fprintf(' %c ',char(dark_all_ch{bin}+32));
    tch = dark_all_ch{bin};
    chb(i,1:length(tch)) = tch;
    fprintf('\n');
end
fprintf('"%c;',char(chb(end:-1:1,1)+31));
fprintf("\n");
fprintf('"%c;',char(chb(end:-1:1,2)+31));
fprintf("\n");
fprintf('"%c;',char(chb(end:-1:1,3)+31));
fprintf("\n");
    
char_img = zeros(height*8, width*levels);
for i=1:levels
    for row=1:8
        t = dark_all_ch{loc(i)};
        for n=1:length(t)
          char_img(((row-1)*height+1):row*height,((i-1)*width+1):((i-1)*width+size(ch{1},2))) = ...
             min(char_img(((row-1)*height+1):row*height,((i-1)*width+1):((i-1)*width+size(ch{1},2))) + ...
             ch{t(n)},max(255,255*over_darken^(n-1)));
         
        end
    end
end
figure
colormap(gray)
imagesc(char_img);
    
