function [data, pic] = display_picture(name, outfn)
   pkg load image
   close all

   fid = fopen(name);
   data = conv_12(fread(fid, 4, 'uint8'));
   data2 = conv_12(fread(fid, data(2)*2-4, 'uint8'));
   data = [data; data2];
%data
   pictures = bitand(data(1),7);
   picsize = data(3)*4096 + data(4);
   pic = conv_12(fread(fid, picsize*2, 'uint8'));
   if pictures >= 2
      picz = conv_12(fread(fid, 1024*2-data(2)*2, 'uint8'));
      pic2 = conv_12(fread(fid, picsize*2, 'uint8'));
      pic = [pic; pic2];
   end
   if pictures >= 3
      pic3 = conv_12(fread(fid, picsize*2, 'uint8'));
      pic = [pic; pic3];
   end
   picz = conv_12(fread(fid, 1024*2, 'uint8'));

   pic(pic >= 2048) = pic(pic >= 2048) - 4096;
   low = min(min(pic))
   high = max(max(pic))
   pic = (pic - low) / (high-low);
   fprintf("Format %04o, header size %d picture size %d ok online %d print title %d\n", ...
      data(1), data(2), picsize, data(5) == 0, data(6) == 0);
   if floor(data(1) / 512) == 1
      psize = '132x79';
      pic = reshape(pic, [79 132]);
   elseif floor(data(1) / 512) == 0
      psize = '140x132';
      pic = reshape(pic, [132 140])';
      pic = flipud(pic);
   elseif floor(data(1) / 512) == 2
      psize = '640x480';
      pic = reshape(pic, [480 640 pictures]);
      picb = zeros(480,640, pictures);
      for n=1:pictures
% Some pictures has the odd and even fields swapped
if exist('fields-swapped')
         picb(2:2:480,:,n) = pic(1:240,:,n);
         picb(1:2:480,:,n) = pic(241:480,:,n);
else
         picb(1:2:480,:,n) = pic(1:240,:,n);
         picb(2:2:480,:,n) = pic(241:480,:,n);
endif
      end
      pic = squeeze(picb);
      pic = imrotate(pic, 90);
   else
      fprintf('Illegal size field\n');
      return;
   end
   cnt = 0;
   ptitle = '';
   while data(7+cnt) ~= 0
      % Remove typo thas messes up command lines for creating picture
      if char(data(7+cnt)) ~= '\'
         ptitle = [ptitle char(data(7+cnt))];
      end
      cnt = cnt + 1;
   end
   fprintf("%s\n",ptitle);
   t = pwd;
   i = strfind(t,'/');
   if data(5) == 0
      fn = [t((i(end)+1):end)  '-'  name];
      outfn = [fn '.png'];
      f = fopen([fn '.txt'],'w');
      fprintf(f,'%s', ptitle);
      fclose(f);
   end

   imagesc(pic);
   axis image;
   cmap = linspace(0,1,256);
   cmap = repmat(cmap,3,1)';
   colormap(cmap);
   fclose(fid);
   if exist("outfn")
      low = min(pic(:));
      high = max(pic(:)); 
      pic_scaled = (pic - low) / (high - low);
      if size(pic_scaled,3) == 1
         pic_rgb = zeros(size(pic,1), size(pic,2), 3);
         pic_rgb(:,:,1) = pic_scaled;
         pic_rgb(:,:,2) = pic_scaled;
         pic_rgb(:,:,3) = pic_scaled;
      else
         pic_rgb = pic_scaled;
      end
      imwrite(pic_rgb, 'tmp.png')
      % Octave doesn't support comment or description
      system(['convert tmp.png -set Comment "' ptitle '" ' outfn]);
      delete 'tmp.png'
      %hist(pic_scaled,50);
      % If RGB picture find best shifting to align colors. Only shifting
      % in x, horizontal
      if size(pic,3) == 3
         cc = normxcorr2(pic_rgb(:,:,1), pic_rgb(:,:,2));
         [max_cc, imax] = max(abs(cc(:)));
         [ypeak2, xpeak2] = ind2sub(size(cc),imax(1));
         ysize = size(pic_rgb,1);
         xsize = size(pic_rgb,2);
         yshift2 = ypeak2 - ysize
         xshift2 = xpeak2 - xsize
         if xshift2 > 0
            pic_rgb(:,1:xsize-xshift2,2) = pic_rgb(:,xshift2+1:xsize,2);
         elseif xshift2 < 0 
            pic_rgb(:,-xshift2+1:xsize,2) = pic_rgb(:,1:xsize+xshift2,2);
         end
         cc = normxcorr2(pic_rgb(:,:,1), pic_rgb(:,:,3));
         [max_cc, imax] = max(abs(cc(:)));
         [ypeak3, xpeak3] = ind2sub(size(cc),imax(1));
         yshift3 = ypeak3 - ysize
         xshift3 = xpeak3 - xsize
         if xshift3 > 0 
            pic_rgb(:,1:xsize-xshift3,3) = pic_rgb(:,xshift3+1:xsize,3);
         elseif xshift3 < 0 
            pic_rgb(:,-xshift3+1:xsize,3) = pic_rgb(:,1:xsize+xshift3,3);
         end
         figure
         imagesc(pic_rgb);
         axis image;
         imwrite(pic_rgb, 'tmp.png')
         % Octave doesn't support comment or description
         system(['convert tmp.png -set Comment "' ptitle '" ' fn '_reg.png']);
         delete 'tmp.png'
      end
   end
end

function out = conv_12(data)
   if 0
      % Old packed format
      ndx = 1;
      out = zeros(1,length(data) * 2 / 3);
      n = 1:3:(length(data)-2);
      ndx = 1:2:(length(data)*2/3);
      out(ndx) = data(n) + bitand(data(n+2), 240) * 16;
      out(ndx+1) = data(n+1) + bitand(data(n+2), 15) * 256;
   else
      if 0
         % two 6 bit words
         out = data(1:2:end) * 64 + data(2:2:end);
      else
         % 12 bit in two bytes
         out = data(1:2:end) + data(2:2:end) * 256;
      end
   end
end
