pkg load image
close all;
img = imread('txt1.png');

img_gray = 255 - mean(img,3);


if 0
   imagesc(img_gray);
   colormap(gray)
   axis image;
end

thresh = 90;

over_darken = 1.2;

col_sums = sum(img_gray,1);

first_col = find(col_sums > thresh, 1);
last_col = find(col_sums > thresh, 1,'last');

split = (last_col - first_col) / 63;

first_col = first_col-round(split*1.2);
last_col = last_col + round(split/15);

split = (last_col - first_col) / 64;

%split = split * .9999;

bounds = first_col + round((0:64)*split);


height = size(img,1);
width = round(split*1.5);
char_img = zeros(height*4, width*16);
row = 1;
col = 1;
dark = zeros(1,63);
dark_ch = cell(63,1);
for i=1:64
    matrix = img_gray(:,bounds(i):(bounds(i+1)-1));
    char_img(((row-1)*height+1):row*height,((col-1)*width+1):((col-1)*width+bounds(i+1)-bounds(i))) = matrix;
    dark(i) = sum(sum(img_gray(:,bounds(i):bounds(i+1))));
    dark_ch{i} = [i];
    matrix=matrix/sum(matrix(:));
    [m,n]=size(matrix);
    [m,n]=ndgrid(1:m,1:n);
    col = col + 1;
    if col > 16;
        col = 1;
        row = row + 1;
    end
end
for i=1:16
    char_img(1:height*4,round((i-1)*width+split)) = 32;    
    char_img(1:height*4,i*width) = 32;
end

%imagesc(char_img);
    
if 0
   [dark_sort, ix] = sort(dark);
   dark_ch_sort = dark_ch(ix);
   figure
   plot(linspace(0,100,length(dark_sort)),dark_sort);
end

dark2 = zeros(floor(63*63/2),1);
ndx = 1;
ch = cell(64,1);
for ch1 = 1:64
   t = img_gray(:,bounds(ch1):(bounds(ch1+1)-1));
   t(1,ceil(split)) = 0;
   ch{ch1} = t;
end

files = dir('*-pic.txt');

for i=1:numel(files)
   file = files(i).name
   height = 145;
   width = 132;
   ch_height = size(ch{1},1);
   ch_width = size(ch{1},2);
   img = zeros(ch_height * height, ch_width * width);
   chars = fileread(file);
   line = 0;
   col = 0;
   over_darken = ones(ch_height, ch_width) * 255 * 1.2;
   cnt = 0;
   for c = chars
      cnt = cnt + 1;
      if c == "\r"
          col = 0;
      elseif c == "\n"
         line = line + 1;
         if line >= height
            break
         end
      else
         x = line * ch_height + 1;
         y = col * ch_width + 1;
         img(x:x+ch_height-1,y:y+ch_width-1) = min(over_darken, img(x:x+ch_height-1,y:y+ch_width-1) + ...
            ch{c - ' ' + 1});
         col = col + 1;
      end
   end
   img = max(over_darken(:)) - img;
   if 0
      figure
      imagesc(img)
      colormap(gray)
      axis image
   end

   pic = uint8(img * 255 / max(img(:)));
   imwrite(pic, strrep(file,'.txt','.png'))
   imwrite(imresize(pic, .10), strrep(file,'.txt','-small.png'))
end
